SystemOrganization addCategory: #'OB-TraitsIntegration'!
SystemOrganization addCategory: #'OB-TraitsIntegration-Nodes'!
SystemOrganization addCategory: #'OB-TraitsIntegration-Traits'!

Trait named: #OBTNestedObject
	uses: {}
	category: 'OB-TraitsIntegration-Traits'!

!OBTNestedObject methodsFor: 'accessing' stamp: 'jk 8/14/2007 07:54'!
nestedObject
	self explicitRequirement ! !

!OBTNestedObject methodsFor: 'accessing' stamp: 'jk 8/14/2007 07:54'!
nestedObject: anObject
	self explicitRequirement ! !

Trait named: #OBTNodeName
	uses: OBTNestedObject
	category: 'OB-TraitsIntegration-Traits'!

OBTNodeName classTrait
	uses: OBTNestedObject classTrait!

!OBTNodeName methodsFor: 'public' stamp: 'jk 8/14/2007 07:56'!
name
	^ self nestedObject asString! !

!OBTNodeName methodsFor: 'printing' stamp: 'jk 8/14/2007 08:01'!
printOn: aStream
	aStream
		print: self class;
		nextPut: $<;
		print: self name;
		nextPut: $>! !

Trait named: #OBTParentNode
	uses: OBTNestedObject
	category: 'OB-TraitsIntegration-Traits'!

OBTParentNode classTrait
	uses: OBTNestedObject classTrait!

!OBTParentNode classSide methodsFor: 'instance creation' stamp: 'jk 8/14/2007 08:03'!
on: aNestedObject of: aParentNode
	^ self new on: aNestedObject of: aParentNode! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:03'!
on: aNestedObject of: aParentNode
	self parentNode: aParentNode.
	self nestedObject: aNestedObject! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:02'!
parentNode
	self explicitRequirement ! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:02'!
parentNode: anObject
	self explicitRequirement! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 09:01'!
theClass
	^ self parentNode theClass! !

!OBTParentNode methodsFor: 'public' stamp: 'jk 8/14/2007 08:56'!
withAllParents
	^ (OrderedCollection new)
		add: self nestedObject;
		addAll: self parentNode withAllParents;
		yourself! !

OBCmdClassTemplate subclass: #OBCmdNewTraitTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdNewTraitTemplate methodsFor: 'accessing' stamp: 'dc 4/23/2007 15:03'!
label
	^ 'new trait template'! !

!OBCmdNewTraitTemplate methodsFor: 'private' stamp: 'dc 7/22/2007 21:04'!
templateDefinition
	^ OBClassDefinition 
			environment: self currentEnvironment
			template: (Trait newTemplateIn: self currentCategory)! !

!TCommentDescription methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:34'!
asCommentNode
	^ OBClassCommentNode on: self theNonMetaClass 
! !

!OBClassAwareNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/14/2007 08:57'!
withAllParents
	^ (OrderedCollection new)
		add: self theClass;
		yourself! !

OBClassAwareNode subclass: #OBTraitTransformationNode
	uses: OBTNodeName + OBTParentNode
	instanceVariableNames: 'parentNode transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Nodes'!

OBTraitTransformationNode class
	uses: OBTNodeName classTrait + OBTParentNode classTrait
	instanceVariableNames: ''!

!OBTraitTransformationNode methodsFor: 'navigating' stamp: 'jk 8/14/2007 09:02'!
allCategory
	^ Array new.! !

!OBTraitTransformationNode methodsFor: 'navigating' stamp: 'jk 8/14/2007 09:03'!
categories
	^ Array new.! !

!OBTraitTransformationNode methodsFor: 'navigating' stamp: 'jk 8/14/2007 09:03'!
dynamicProtocols
	^ Array new.! !

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:52'!
nestedObject
	^ transformation! !

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:52'!
nestedObject: anObject
	transformation := anObject! !

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:51'!
parentNode
	^ parentNode! !

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:51'!
parentNode: anObject
	parentNode := anObject! !

OBClassCommentNode subclass: #OBTraitTransformationCommentNode
	uses: OBTNodeName + OBTParentNode
	instanceVariableNames: 'parentNode transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Nodes'!

OBTraitTransformationCommentNode class
	uses: OBTNodeName classTrait + OBTParentNode classTrait
	instanceVariableNames: ''!

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:26'!
nestedObject
	^ transformation! !

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:26'!
nestedObject: anObject
	transformation := anObject! !

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:27'!
parentNode
	^ parentNode! !

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:27'!
parentNode: anObject
	parentNode := anObject! !

OBClassCommentNode subclass: #OBUsedTraitCommentNode
	uses: OBTNodeName + OBTParentNode
	instanceVariableNames: 'parentNode trait'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Nodes'!

OBUsedTraitCommentNode class
	uses: OBTNodeName classTrait + OBTParentNode classTrait
	instanceVariableNames: ''!

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:46'!
nestedObject
	^ trait! !

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:46'!
nestedObject: anObject
	trait := anObject ! !

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:46'!
parentNode
	^ parentNode! !

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:47'!
parentNode: anObject
	parentNode := anObject ! !

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:47'!
theClass
	^ self nestedObject! !

!OBCmdFindClass class methodsFor: '*ob-traitsIntegration' stamp: 'dc 5/17/2007 12:57'!
on: target for: requestor
	^ OBCmdFindClassOrTrait new setTarget: target requestor: requestor! !

OBCmdFindClass subclass: #OBCmdFindClassOrTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdFindClassOrTrait methodsFor: 'private' stamp: 'dc 5/17/2007 12:54'!
allBehaviorsIn: anEnvironment
	^ Array streamContents: [:stream|
		
		stream
			nextPutAll: anEnvironment classNames;
			nextPutAll: anEnvironment traitNames 
		
		]! !

!Trait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:34'!
asClassSideNode
	^ OBMetaclassNode on: self
! !

!Trait methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/14/2007 11:49'!
asCommentNodeOf: aParentNode 
	^ OBUsedTraitCommentNode on: self of: aParentNode! !

!Trait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:35'!
asNode
	^ OBClassNode on: self
! !

!Trait methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/14/2007 08:09'!
asNodeOf: aParentNode
	^ OBUsedTraitNode on: self of: aParentNode! !

!OBMetagraphBuilder methodsFor: '*ob-traitsintegration-private' stamp: 'jk 8/14/2007 11:39'!
populateTraitFilter
	| classesWithUsedTraits |
	classesWithUsedTraits := OBMetaNode named: 'ClassWithUsedTraits'.
	root childAt: classSel labeled: 'traits' put: classesWithUsedTraits.
	classesWithUsedTraits 
		childAt: #usedTraits
			labeled: 'instance'
			put: class;
		childAt: #commentsOfUsedTraits
			labeled: '?'
			put: comment;
"		childAt: metaclassSel
			labeled: 'class'
			put: metaclass;"
		addFilter: OBModalFilter new;
		addFilter: OBClassSortFilter new! !

!TraitTransformation methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/14/2007 11:42'!
asCommentNodeOf: aParentNode 
	^ OBTraitTransformationCommentNode on: self of: aParentNode! !

!TraitTransformation methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/14/2007 08:53'!
asNodeOf: aParentNode
	^ OBTraitTransformationNode on: self of: aParentNode! !

!OBCodeBrowser methodsFor: '*ob-traitsIntegration' stamp: 'jk 6/20/2007 17:23'!
cmdBrowseMethodImplementor
	^ OBCmdBrowseMethodImplementor! !

!OBCodeBrowser methodsFor: '*ob-traitsIntegration' stamp: 'ab 6/5/2007 23:50'!
cmdBrowseTraitUser
	^OBCmdBrowseTraitUsers! !

!OBCodeBrowser methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/23/2007 15:04'!
cmdNewTraitTemplate
	^ OBCmdNewTraitTemplate ! !

!OBClassCategoryNode methodsFor: '*ob-traitsintegration' stamp: 'jk 8/13/2007 16:23'!
addTraitsOf: aClassOrTrait into: aCollection ofParentNode: aNode
	aClassOrTrait traitTransformations do: [ :t | | n |
			n := t asNodeOf: aNode.
			aCollection add: (t asNodeOf: aNode).
			self addTraitsOf: t into: aCollection ofParentNode: n.
		].
	^ aCollection
! !

!OBClassCategoryNode methodsFor: '*ob-traitsintegration' stamp: 'jk 8/13/2007 16:23'!
usedTraits
	| classes result |
	classes := self classes.
	result := OrderedCollection new.
	classes do: [ :node |
				result add: node.
				self addTraitsOf: node theClass into: result ofParentNode: node. ].
	^ result! !

!OBAnnotationRequest methodsFor: '*ob-traitsIntegration' stamp: 'jk 6/20/2007 14:03'!
messageComesFrom
	class isNil ifTrue: [^ String new].
	selector isNil ifTrue: [^ class printString ].
	^ (class traitOrClassOfSelector: selector) printString! !

!ClassTrait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:33'!
asClassSideNode
	^ OBMetaclassNode on: self baseTrait
! !

!ClassTrait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:33'!
asNode
	^ OBMetaclassNode on: self
! !

OBCommand subclass: #OBCmdBrowseMethodImplementor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdBrowseMethodImplementor methodsFor: 'execution' stamp: 'jk 6/20/2007 16:33'!
execute
	| class |
	class := target theClass traitOrClassOfSelector: target selector.
	(OBMethodNode on: target selector inClass: class) browse! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:34'!
group
	^ #navigation! !

!OBCmdBrowseMethodImplementor methodsFor: 'testing' stamp: 'jk 6/20/2007 16:28'!
isActive
	^ (target isKindOf: OBMethodNode)
		and: [requestor isSelected: target]! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:38'!
keystroke
	^ $M! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:27'!
label
	^ 'browse method implementor'! !

OBCommand subclass: #OBCmdBrowseTraitUsers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdBrowseTraitUsers methodsFor: 'execution' stamp: 'ab 6/6/2007 00:00'!
execute
	| users usersNames selection |
	"ugly hack to get rid of double..."
	users := target theClass users asOrderedCollection asSet asOrderedCollection.
	(users size = 0)
		ifTrue: [Beeper beep. ^ self].
	(users size = 1)
		ifTrue: [users first browse. ^ self].
		
	usersNames := users asOrderedCollection collect: [:clsOrTrait| clsOrTrait name].
	selection := OBChoiceRequest prompt: nil labels: usersNames values: users.
	selection ifNotNil: [selection browse].! !

!OBCmdBrowseTraitUsers methodsFor: 'testing' stamp: 'ab 6/5/2007 23:52'!
isActive

	^ ((target isKindOf: OBClassNode) and: 
		[target theClass isTrait]) and:
			[requestor isSelected: target]! !

!OBCmdBrowseTraitUsers methodsFor: 'accessing' stamp: 'ab 6/5/2007 23:48'!
keystroke
	^ $u! !

!OBCmdBrowseTraitUsers methodsFor: 'accessing' stamp: 'ab 6/5/2007 23:48'!
label
	^ 'browse trait users...'! !

!OBClassNode methodsFor: '*ob-traitsintegration-navigating' stamp: 'jk 8/14/2007 11:37'!
addTraitsOf: aClassOrTrait bySelector: aSelector into: aCollection ofParentNode: aNode 
	aClassOrTrait traitTransformations
		do: [:t | 
			| n | 
			n := t asNodeOf: aNode.
			aCollection
				add: (t perform: aSelector with: aNode).
			self
				addTraitsOf: t
				bySelector: aSelector
				into: aCollection
				ofParentNode: n].
	^ aCollection! !

!OBClassNode methodsFor: '*ob-traitsintegration-navigating' stamp: 'jk 8/14/2007 11:36'!
commentsOfUsedTraits
	| result |
	result := OrderedCollection new.
	result add: self copy.
	self addTraitsOf: self theClass bySelector: #asCommentNodeOf: into: result ofParentNode: self.
	^ result! !

!OBClassNode methodsFor: '*ob-traitsintegration-navigating' stamp: 'jk 8/14/2007 11:34'!
usedTraits
	| result |
	result := OrderedCollection new.
	result add: self copy.
	self addTraitsOf: self theClass bySelector: #asNodeOf: into: result ofParentNode: self.
	^ result! !

OBClassNode subclass: #OBUsedTraitNode
	uses: OBTParentNode + OBTNodeName
	instanceVariableNames: 'trait parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Nodes'!

OBUsedTraitNode class
	uses: OBTParentNode classTrait + OBTNodeName classTrait
	instanceVariableNames: ''!

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:06'!
nestedObject
	^ trait! !

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:06'!
nestedObject: anObject
	trait := anObject! !

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:07'!
parentNode
	^ parentNode! !

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:07'!
parentNode: anObject
	parentNode := anObject ! !

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 09:05'!
theClass
	^ self nestedObject! !
